import { QueryHandler } from '@nestjs/cqrs';
import { ICollection } from 'src/modules/database/src/interfaces/collection.interface';
import { ConfigurationRepository } from '../../adapters/secondaries/configuration.repository';
import { FindAllConfigurationsQuery } from '../../queries/find-all-configurations.query';
import { Configuration } from '../entities/configuration';

@QueryHandler(FindAllConfigurationsQuery)
export class FindAllConfigurationsUseCase {
  constructor(private readonly _repository: ConfigurationRepository) {}

  async execute(
    findAllConfigurationsQuery: FindAllConfigurationsQuery,
  ): Promise<ICollection<Configuration>> {
    return this._repository.findAll(
      findAllConfigurationsQuery.page,
      findAllConfigurationsQuery.perPage,
    );
  }
}
